      SUBROUTINE MNL3R(N,X,XMIN,S,FUN,GRAD,AA,BB,XE,GE,I0,UP,RM,IERR)
C
C    OHOMEPHA MHMA YHK MHOX EPEMEHHX
C    O AAHHOMY HAPABEH  HA AAHHOM HTEPBAE
C
C    APAMETP:
C    N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX
C    X     -HAAHA TOKA OCKA
C    XMIN  -PACCTOHE OT X O BCEHHO TOK
C    S     -BEKTOP H N - HAPABEHE OCKA
C    FUN   -M OPOPAMM BCEH YHK
C    GRAD  -M OPOPAMM BCEH PAEHTA
C    AA,BB -HH  BEPXH PAH HTEPBAA,
C    XE    -TOHOCT O APYMEHTY
C    GE    -TOHOCT O PAEHTY
C    I    -KOPPEKTPY BEKTOP H N
C    UP    -BEKTOP YPABX APAMETPOB
C    RM    -PAO BEKTOP H 3N
C    IERR  -PHAK OKOHAH POECCA:
C          1 -OCTHYTA TOHOCT XE
C          3 -OCTHYTA TOHOCT GE
C          4 -BOHEHO UP(1) TEPA
C          65-GRAD HA EBOM KOHE OTPEKA .GE.
C              HA PABOM .LE.
C          66-BEKTOP S  I OPTOOHAH
C
         INTEGER I0,IERR,N
         REAL AA,BB,GE,RM,S,UP,X,XE,XMIN
         DIMENSION I0(1),RM(1),S(1),UP(1),X(1)
         EXTERNAL MNL31,MNL32
         INTEGER I,I1,I2,ITER,IUP1,IUP2
         REAL A,B,F1,F2,FE,FV,G1,G2,GX,RS,V,W,Z,ZERO
         DATA RS,ZERO/0.,0./
       IUP1 = UP(1) + 0.5
       IUP2 = UP(2) + 0.5
       ITER = 0
       A = AA
       B = BB
       I1 = N
       I2 = 2*N
C
C    BCEHE HOPM BEKTOPA S C YETOM I
C
       DO 10 I = 1, N
          IF (I0(I) .LE. ZERO) GO TO 10
             RS = RS + S(I)**2
   10  CONTINUE
       IF (RS .GT. ZERO) GO TO 20
          IERR = 66
          GO TO 160
   20  CONTINUE
       RS = SQRT(RS)
       CALL MNL31(N,X,S,A,RM,I0,0)
       CALL MNL31(N,X,S,B,RM,I0,I1)
       CALL GRAD(RM(1),RM(I2+1),GE,I0)
       CALL MNL32(N,RM,S,RS,G1,I0,I2)
       CALL GRAD(RM(I1+1),RM(I2+1),GE,I0)
       CALL MNL32(N,RM,S,RS,G2,I0,I2)
C
C    POBEPKA HAKOB POBOHO HA KOHAX (A,B)
C
       IF ((G1 .GE. ZERO) .OR. (G2 .LE. ZERO)) GO TO 90
C
C    POBEPKA H KOHTPOHOO OTPEKA
C
          IF ((B - A)*.5 .LE. XE) GO TO 100
             CALL FUN(RM(1),F1,FE)
             CALL FUN(RM(I1+1),F2,FE)
   30     CONTINUE
          ITER = ITER + 1
C
C    POBEPKA CA TEPA
C
          IF (ITER .GE. IUP1) GO TO 120
C
C    POBEPKA H KOHTPOHOO OTPEKA
C
             IF ((B - A)*.5 .LE. XE) GO TO 100
C
C    BCEHE POMEYTOHO TOK (A,B)
C
                GO TO (40,50,60),IUP2
   40     CONTINUE
          V = (F1 - F2 + B*G2 - A*G1)/(G2 - G1)
          GO TO 70
   50  CONTINUE
       V = (B*G2 - A*G1)/(G2 - G1)
       GO TO 70
   60  CONTINUE
       Z = 3.*(F1 - F2)/(B - A)
       Z = Z + G1 + G2
       W = Z*Z - G1*G2
       W = SQRT(W)
       V = (Z + G2 - W)*(B - A)/(G2 + G1 + 2*Z)
       V = B - V
   70  CONTINUE
       CALL MNL31(N,X,S,V,RM,I0,0)
       CALL GRAD(RM(1),RM(I2+1),GE,I0)
       CALL MNL32(N,RM,S,RS,GX,I0,I2)
       CALL FUN(RM(1),FV,FE)
       IF (GX .LE. GE) GO TO 80
C
C    CTAPOE V CTAHOBTC HOBM B
C
          B = V
          F2 = FV
          G2 = GX
          GO TO 30
   80  CONTINUE
       IF (GX .GE. -GE) GO TO 130
C
C    CTAPOE V CTAHOBTC HOBM A
C
          A = V
          F1 = FV
          G1 = GX
          GO TO 30
C
C    OPEEEHE BXOHX APAMETPOB
C
   90  CONTINUE
       IERR = 65
       GO TO 140
  100  CONTINUE
       IERR = 1
       GO TO 140
  110  CONTINUE
       IERR = 2
       GO TO 140
  120  CONTINUE
       IERR = 4
       GO TO 140
  130  CONTINUE
       IERR = 3
       XMIN = V
       GO TO 160
  140  CONTINUE
       IF (F1 .GT. F2) GO TO 150
          XMIN = A
          GO TO 160
  150  CONTINUE
       XMIN = B
  160  RETURN
      END
